var _variableMap;

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import { css, StyleSheet } from '@patternfly/react-styles';
import styles from "../../@patternfly/patternfly/components/BackgroundImage/background-image.css.js";
/* eslint-disable camelcase */

import { c_background_image_BackgroundImage, c_background_image_BackgroundImage_2x, c_background_image_BackgroundImage_sm, c_background_image_BackgroundImage_sm_2x, c_background_image_BackgroundImage_lg, c_background_image_Filter } from '@patternfly/react-tokens';
export var BackgroundImageSrc = {
  xs: 'xs',
  xs2x: 'xs2x',
  sm: 'sm',
  sm2x: 'sm2x',
  lg: 'lg',
  filter: 'filter'
};
var variableMap = (_variableMap = {}, _defineProperty(_variableMap, BackgroundImageSrc.xs, c_background_image_BackgroundImage && c_background_image_BackgroundImage.name), _defineProperty(_variableMap, BackgroundImageSrc.xs2x, c_background_image_BackgroundImage_2x && c_background_image_BackgroundImage_2x.name), _defineProperty(_variableMap, BackgroundImageSrc.sm, c_background_image_BackgroundImage_sm && c_background_image_BackgroundImage_sm.name), _defineProperty(_variableMap, BackgroundImageSrc.sm2x, c_background_image_BackgroundImage_sm_2x && c_background_image_BackgroundImage_sm_2x.name), _defineProperty(_variableMap, BackgroundImageSrc.lg, c_background_image_BackgroundImage_lg && c_background_image_BackgroundImage_lg.name), _defineProperty(_variableMap, BackgroundImageSrc.filter, c_background_image_Filter && c_background_image_Filter.name), _variableMap);
export var propTypes = {
  /** Additional classes added to the background. */
  className: PropTypes.string,

  /** Override image styles using a string or BackgroundImageSrc */
  src: PropTypes.oneOfType([PropTypes.string, PropTypes.shape({
    xs: PropTypes.string,
    xs2x: PropTypes.string,
    sm: PropTypes.string,
    sm2x: PropTypes.string,
    lg: PropTypes.string,
    filter: PropTypes.string
  })]).isRequired
};
export var defaultProps = {
  className: ''
};

var BackgroundImage = function BackgroundImage(_ref) {
  var className = _ref.className,
      src = _ref.src,
      props = _objectWithoutProperties(_ref, ["className", "src"]);

  // Default string value to handle all sizes
  var variableOverrides = typeof src === 'string' ? Object.keys(BackgroundImageSrc).reduce(function (prev, size) {
    return _objectSpread({}, prev, _defineProperty({}, BackgroundImageSrc[size], src));
  }, {}) : src;
  var bgStyles = StyleSheet.create({
    bgOverrides: "&.pf-c-background-image {\n      ".concat(Object.keys(variableOverrides).reduce(function (prev, size) {
      return "".concat(prev.length ? prev : '').concat(variableMap[size], ": url('").concat(variableOverrides[size], "');");
    }, {}), "\n    }")
  });
  return React.createElement("div", {
    className: css(styles.backgroundImage, bgStyles.bgOverrides, className)
  });
};

BackgroundImage.propTypes = propTypes;
BackgroundImage.defaultProps = defaultProps;
export default BackgroundImage;