export declare function capitalize(input: string): string;
export declare function getUniqueId(prefix?: string): string;
export declare function debounce(func: (...args: any[]) => any, wait: number): (...args: any[]) => void;
/** This function returns the side the element is out of view on (right, left or both)
 * @param {Object} container  The container to check if the element is in view of.
 * @param {Object} element    The element to check if it is view
 * @param {boolean} partial   true if partial view is allowed
 *
 * @return {type} True if the component is in View.
 */
export declare function isElementInView(container: any, element: any, partial: any): boolean;
/** This function returns the side the element is out of view on (right, left or both)
 * @param {Objent} container    The container to check if the element is in view of.
 * @param {Object} element      The element to check if it is view
 *
 * @return {type} right if the element is of the right, left if element is off the left or both if it is off on both sides.
 */
export declare function sideElementIsOutOfView(container: any, element: any): string;
/** This function returns the side the element is out of view on (right, left or both)
 * @param {Object} templateString  The string passed by the consumer
 * @param {Object} templateVars The variables passed to the string
 *
 * @return {type} The template string literal result
 */
export declare function fillTemplate(templateString: any, templateVars: any): any;
/** This function allows for keyboard navigation through dropdowns. The custom argument is optional.
 * @param {number} index The index of the element you're on
 * @param {string} position The orientation of the dropdown
 * @param {string[]} refsCollection Array of refs to the items in the dropdown
 * @param {Object[]} kids Array of items in the dropdown
 * @param {boolean} [custom] Allows for handling of flexible content
 */
export declare function keyHandler(index: any, position: any, refsCollection: any, kids: any, custom?: boolean): void;
